# include <population.h>
# include <fparser.hh>
FunctionParser parser;
double fitness(Node *n)
{
    QString s=n->print();
    parser.Parse(s.toStdString(),"x");
    QVector<double> xpoint;
    QVector<double> ypoint;
    for(double x=0.0;x<=1.0;x+=0.1)
    {
        xpoint<<x;
        ypoint<<(x*x);
    }
    double sum=0.0;
    for(int i=0;i<xpoint.size();i++)
    {
        double xx[1];
        xx[0]=xpoint[i];
        double f=parser.Eval(xx);
        double y=ypoint[i];
        sum+=(f-y)*(f-y);
    }
    printf("sum = %lf \n",sum);
    return sum;
}


int main(int argc, char *argv[])
{

    QStringList BinarySet;
    BinarySet<<"+"<<"-"<<"*"<<"/";
    QStringList UnarySet;
    UnarySet<<"abs"<<"sin"<<"cos"<<"log";
    QStringList VariableSet;
    VariableSet<<"x";
    QStringList ConstantSet;
    ConstantSet<<"1";
    Population pop(500,BinarySet,UnarySet,VariableSet,ConstantSet,fitness);
    for(int g=1;g<=200;g++)
    {
        pop.nextGeneration();
        QString s=pop.getBest()->print();
        printf("Best chromosome %s\n",s.toStdString().c_str());
    }
    return 0;
}
