#include "node.h"
# include <QString>
Node::Node(Node *r,QString v,int t)
{
    root=r;
    value=v;
    type=t;
    left=NULL;
    right=NULL;
}


void    Node::copyFromOther(Node *x)
{

    root=x->getroot();
    type=x->gettype();
    value=x->getvalue();
    left=NULL;
    right=NULL;
    if(type==NODE_UNARY)
    {
        setleft(x->getleft());
    }
    else
    if(type==NODE_BINARY)
    {
      setleft(x->getleft());
      setright(x->getright());
    }
}

int     Node::gettype()
{
    return type;
}

Node    *Node::getroot()
{
    return root;
}

void    Node::setleft(Node *l)
{
    left=l;
}

void    Node::setright(Node *r)
{
    right=r;
}

Node    *Node::getleft()
{
    return left;
}

Node    *Node::getright()
{
    return right;
}

QString Node::getvalue()
{
    return value;
}

QString Node::print()
{
    if(type==NODE_CONSTANT || type==NODE_VARIABLE)
        return value;
    else
    if(type==NODE_UNARY)
        return value+"("+left->print()+")";
    else
        return "("+left->print()+value+right->print()+")";
}

void Node::setRandomNode(double prob,Node *other)
{
    double r=rand() * 1.0/RAND_MAX;
    if(r<=prob)
    {
        copyFromOther(other);
        return ;
    }
    int d=getdepth();
    if(d==1)
    {
        copyFromOther(other);
        return ;
    }
    else
    {
        if(type==NODE_UNARY)
            left->setRandomNode(1.0/d,other);
        else
        {
            int binary_rand=rand() %2;
            if(binary_rand==0) left->setRandomNode(1.0/d,other);
            else right->setRandomNode(1.0/d,other);
        }
    }
}

int Node::getdepth()
{

    if(type==NODE_CONSTANT||type==NODE_VARIABLE) return 1;
    else
    if(type==NODE_UNARY)
        return 1+(left==NULL)?0:left->getdepth();
    else
    if(type==NODE_BINARY)
    {
        int m1=left==NULL?0:left->getdepth();
        int m2=right==NULL?0:right->getdepth();
        return 1+((m1<m2)?m1:m2);
    }
    return 0;
}

Node *Node::randomNode(double prob)
{
    double r=rand() * 1.0/RAND_MAX;
    if(r<=prob) return this;
    int d=getdepth();
    if(d==1) return this;
    else
    {
        if(type==NODE_UNARY)
            return left->randomNode(1.0/d);
        else
        {
            int binary_rand=rand() %2;
            if(binary_rand==0) return left->randomNode(1.0/d);
            else return right->randomNode(1.0/d);
        }
    }
    return NULL;
}

Node::~Node()
{

    if(type==NODE_UNARY && left!=NULL) delete left;
    else
    if(type==NODE_BINARY)
    {
        if(left!=NULL)
        delete left;
        if(right!=NULL)
        delete right;
    }
}
