#ifndef POPULATION_H
#define POPULATION_H
# include <node.h>
# include <QVector>
# include <QStringList>
class Population
{
private:
    QVector<Node*> chromosome;
    QVector<Node*> children;
    QVector<double> fitnessArray;

    QStringList binarySet;
    QStringList unarySet;
    QStringList variableSet;
    QStringList constantSet;

    double selection_rate;
    double mutation_rate;
    int     generation;
    int     tournament();
    double (*fitness_function)(Node *);
    void    calcFitnessArray();
    Node    *makeNode(Node *rootNode,int maxDepth);
public:
    Population(int count,QStringList b,QStringList u,QStringList v,QStringList con,double (*ff)(Node *));
    void setSelectionRate(double r);
    double getSelectionRate();
    void setMutationRate(double r);
    double getMutationRate();
    void    sortChromosomes();
    void    crossover();
    void    mutate();
    Node    *getBest();
    double  getBestFitness();
    void    nextGeneration();
    ~Population();
};

#endif // POPULATION_H
